---
title: NodeIterator.filter
slug: Web/API/NodeIterator/filter
tags:
  - API
  - DOM
  - NodeIterator
  - Property
---
<div>{{APIRef("DOM")}}</div>

<p>The <strong><code>NodeIterator.filter</code></strong> read-only method returns a {{domxref("NodeFilter")}} object, that is an object implement an <code>acceptNode(<em>node</em>)</code> method, used to screen nodes.</p>

<p>When creating the {{domxref("NodeIterator")}}, the filter object is passed in as the third parameter, and the object method <code>acceptNode(<em>node</em>)</code> is called on every single node to determine whether or not to accept it. This function should return the constant <code>NodeFilter.FILTER_ACCEPT</code> for cases when the node should be accepted and <code>NodeFilter.FILTER_REJECT</code> for cases when the node should be rejected.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>nodeFilter</em> = <em>nodeIterator</em>.filter;
</pre>

<h2 id="Example">Example</h2>

<pre class="brush: js">const nodeIterator = document.createNodeIterator(
    document.body,
    NodeFilter.SHOW_ELEMENT,
    { acceptNode: function(node) { return NodeFilter.FILTER_ACCEPT; } },
    false
);
nodeFilter = nodeIterator.filter;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('DOM WHATWG', '#dom-nodeiterator-filter', 'NodeIterator.filter')}}</td>
			<td>{{Spec2('DOM WHATWG')}}</td>
			<td>No change from {{SpecName('DOM2 Traversal_Range')}}.</td>
		</tr>
		<tr>
			<td>{{SpecName('DOM2 Traversal_Range', 'traversal.html#Traversal-NodeIterator-filter', 'NodeIterator.filter')}}</td>
			<td>{{Spec2('DOM2 Traversal_Range')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.NodeIterator.filter")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>The interface this property belongs to: {{domxref("NodeIterator")}}.</li>
</ul>
